*!  version 1.0.1   10/17/00
program define logsub
  version 6.0
  syntax varlist [if] [in]
  quietly logit `varlist' `if' `in'
  quietly lfit
  local pchi2 = r(chi2)
  local g = e(chi2)
  local kk = e(df_m)
  local pp = e(df_m)
  local np1 = e(N) - `pp' - 1
  tokenize `varlist'
  local dv `1'
  macro shift
  local rest `*'
  display
  display in green "Logistic Regression Subsets"
  display
  display in green "Response variable: " in yellow "`dv'"
  display
  local mc = (`pchi2' ) / (`pchi2'/`np1') +  2*(`pp'  + 1) - e(N) 
  local g2 = 0
  display in green "   Cq       chi2   df          `pp' predictor model, no variables removed"
  display %6.2f `mc' "    " %6.2f   `g2' "    " 0  "          "   "`rest'"  
  
  local df2 = `pp' - 1
  display in green "   Cq       chi2   df     p    `df2' predictors, 1 variable removed"
  
  /* loop for one variable models */
  local i = 1
  while "``i''"~="" {
   quietly test ``i''
    local g2= r(chi2)
    local mc = ((`pchi2' + `g2') / (`pchi2'/`np1')) +  2*`pp' - e(N) 
    display %6.2f `mc' "    " %6.2f   `g2'  %5.0f  r(df) "   " %5.3f  r(p)  "  " "``i''"  
    local i = `i' + 1
  }

  /* loop for two variable models */
  local df2 = `pp' - 2
  if `kk' >= 3  {
    display in green "   Cq       chi2   df     p    `df2' predictors, 2 variables removed"
    local i = 1
    while `i'< `kk' {
      local j = `i' + 1
      while `j'<= `kk' {
        quietly test ``i'' ``j'' 
        local g2= r(chi2)
        local mc = ((`pchi2' + `g2')/(`pchi2' /`np1')) +  2*(`pp' - 1) - e(N) 
        display %6.2f `mc' "    " %6.2f  `g2'  %5.0f  r(df)  "   " %5.3f  r(p)  "  "  "``i'' ``j''"  
        local j = `j' + 1
      }
      local i = `i' + 1
    }
  }

  /* loop for three variable models */
  local df2=`pp' - 3
  if `kk' >= 4 {  
    display in green "   Cq       chi2   df     p    `df2' predictors, 3 variables removed"
    local i = 1
    while `i' < `kk' - 1 {
      local j = `i' + 1
      while `j' < `kk' {
        local k = `j' + 1
        while `k' < `kk' + 1 {
          quietly test ``i'' ``j'' ``k'' 
           local g2= r(chi2)
           local mc = ((`pchi2' + `g2')/(`pchi2' /`np1')) +  2*(`pp' - 2) - e(N)
           local df2 = `pp' - e(df_m)
          display  %6.2f  `mc' "    " %6.2f  `g2'  %5.0f  r(df)  "   " %5.3f  r(p)  "  "  "``i'' ``j'' ``k''"  
          local k = `k' + 1
        }
        local j = `j' + 1
      }
      local i = `i' + 1
    }
  }
  
  /* loop for four variable models */
  local df2= `pp' - 4
  if `kk' >= 5{
    display in green "   Cq       chi2   df     p    `df2' predictors, 4 variables removed"
    local i = 1
    while `i' < `kk' - 2 {
      local j = `i' + 1
      while `j' < `kk' -1 {
        local k = `j' + 1
        while `k' < `kk'  {
          local l = `k' + 1
          while `l' < `kk' + 1 {
            quietly test  ``i'' ``j'' ``k'' ``l''
            local g2= r(chi2)
            local mc = (`pchi2' + `g2')/(`pchi2' /`np1') +  2*(`pp' - 3) - e(N)
            display  %6.2f `mc' "    " %6.2f  `g2'  %5.0f  r(df)  "   " %5.3f  r(p)  "  "  "``i'' ``j'' ``k'' ``l''" 
            local l = `l' + 1 
          }
          local k = `k' + 1
        }
        local j = `j' + 1
      }
      local i = `i' + 1
    }  
  }
  
    /* loop for five variable models */
  local df2 = `pp' - 5
  if `kk' >= 6 {
    display in green "   Cq       chi2   df     p    `df2' predictors, 5 variables removed"
    local i = 1
    while `i' < `kk' - 3 {
      local j = `i' + 1
      while `j' < `kk' -2 {
        local k = `j' + 1
        while `k' < `kk' - 1  {
          local l = `k' + 1
          while `l' < `kk' {
            local m = `l' + 1
            while `m' < `kk' + 1 {
             quietly test ``i'' ``j'' ``k'' ``l'' ``m''
              local g2= r(chi2)
              local mc = (`pchi2' + `g2')/(`pchi2' /`np1') +  2*(`pp' - 4) - e(N)
             display  %6.2f  `mc' "    " %6.2f  `g2'  %5.0f  r(df)  "   " %5.3f  r(p)  "  "  "``i'' ``j'' ``k'' ``l'' ``m''" 
             local m = `m' + 1
            }
            local l = `l' + 1 
          }
          local k = `k' + 1
        }
        local j = `j' + 1
      }
      local i = `i' + 1
    }  
  }
  
end
